using System;

namespace ConsoleApp5
{
    internal class Program
    {
        static void Main(string[] args)
        {
            string[] n_k = Console.ReadLine().Split();
            int n = int.Parse(n_k[0]); int k = int.Parse(n_k[1]);
            string[] ulaz = Console.ReadLine().Split(); int[] niz = new int[k]; int[] izlaz = new int[k];
            for (int i = 0; i < k; i++)
            {
                niz[i] = int.Parse(ulaz[i]);
            }
            int[] niz2 = new int[k];
            Array.Copy(niz, niz2, k);
            Array.Sort(niz2);
            for (int i = 0; i < k; i++)
            {
                int rezultat = 0;
                int broj = niz[i];
                int indeks = Array.BinarySearch(niz2, broj);
                for (int j = 0; j <= indeks; j++)
                {
                    if (broj % niz2[j] != 0)
                    {
                        continue;
                    }
                    rezultat = rezultat ^ niz2[j];
                }
                izlaz[i] = rezultat;
            }
            Console.WriteLine(string.Join(" ", izlaz));
        }
    }
}